#!/bin/sh

IFS=
PATH="/usr/sbin:/usr/bin:/sbin:/bin"

LOCALWIFIIP=`ifconfig en0|grep "inet"|awk '{ print $2 }'`
OUTFILE="/tmp/autoscan-list.tmp"
FOUNDFILE="/tmp/autoscan-found.tmp"
TRYCOUNT="+"

# shell variables don't propagate beyond loop scopes, even when exported
rm -f $FOUNDFILE

while [ "x$TRYCOUNT" != "x++++" ]; do
	MASTERBROWSERIPS=`/var/samba/bin/nmblookup -M -- -|grep "<01>"|grep -v "$LOCALWIFIIP"|awk '{ print $1 }'`
	if [ "x$MASTERBROWSERIPS" != "x" ]; then
		echo "$MASTERBROWSERIPS" | while read MASTERBROWSERIP; do
			/var/samba/bin/nmblookup -A $MASTERBROWSERIP|grep "<ACTIVE>" > $OUTFILE
			GROUPNAME=`cat $OUTFILE|grep "<GROUP>"|grep "<00>"|awk '{ print $1 }'`
			if [ "x$GROUPNAME" != "x" ]; then
#				DOMAINNAME=`cat $OUTFILE|grep $GROUPNAME|grep "<1b>"|awk '{ print $1 }'`
#				if [ "x$DOMAINNAME" != "x" ]; then
#					echo "$DOMAINNAME (domain)"
#					echo "1" > $FOUNDFILE
#				fi
				WORKGROUPNAME=`cat $OUTFILE|grep $GROUPNAME|grep "<1d>"|awk '{ print $1 }'`
				if [ "x$WORKGROUPNAME" != "x" ]; then
					echo "$WORKGROUPNAME"
					echo "1" > $FOUNDFILE
				fi
			fi
			rm -f $OUTFILE
		done
	fi

	if [ -f $FOUNDFILE ]; then
		break
	fi

	TRYCOUNT="$TRYCOUNT+"
	sleep 1
done

if [ ! -f $FOUNDFILE ]; then
	exit 1
fi

rm -f $FOUNDFILE
exit 0
